
RSBag - Bug #1098
bag-play 0.8 does not decode type RSB-EVENT-0.7
07/25/2012 01:46 PM - Anonymous

Status: Resolved Start date: 07/25/2012
Priority: Normal Due date:
Assignee: J. Moringen % Done: 100%
Category: Estimated time: 0.00 hour
Target version: rsb-0.9
Description

Replaying the attached file oncilla.tide with rsbag-bin-cl0.7 tools properly moves the oncilla robot in simulation by replaying a bunch of
8-dimensional rst:JointAngles. Replaying it with rsbag-bin-cl0.8 tools seems to replay events with broken/incorrect payload: the robot
interface throws exceptions, that the dimension of the incoming commands is wrong (should be 8-dimensional).

Reproduce by replaying the attached file with bag-play of rsbag-bin-cl0.7 (working) and rsbag-bin-cl0.8 (not working).

(spotted on ubuntu precise 32 bit and 64 bit)

Related issues:
Related to RSBag - Bug # 1099: bag-{play,cat} should fail if no transform is ... Resolved 07/25/2012

Associated revisions
Revision 8f9732d7 - 07/25/2012 09:50 PM - J. Moringen
Added support for rsb-event-0.7 serialization
fixes #1098
    -  compat/0.7: new directory; contains data and code for rsb-event-0.7

  serialization
    -  src/transform/rsb-event-multi-version.lisp (toplevel): define

  rsb-event-0.7 serialization

History
#1 - 07/25/2012 03:38 PM - Anonymous

Difference in the backtrace of bag-cat:

bag-cat0.7 (working):

> bag-cat -E 1 -I /usr/share/rst/proto/stable/ -l /usr/share/rst/proto/stable/rst/kinematics/JointAngles.proto --log-level=trace --trace
'"RSBAG.TRANSFORM"' --style=detailed /usr/share/cca-oncilla/examples/oncilla.tide

WARNING:
   Failed to load Spread library: Unable to load any of the alternatives:
   ("libspread-without-signal-blocking.so" "libspread.so" "libspread.so.2" 
    "libspread.so.2.0" "libspread.so.1").
   Did you set LD_LIBRARY_PATH?
   Spread transport will now be disabled.
[ INFO (RSB.COMMON) ]  Processing IDL file #P"/usr/share/rst/proto/stable/rst/kinematics/JointAngles.proto" 
[ INFO (RSB.COMMON) ]  Parsing data definition from /usr/share/rst/proto/stable/rst/kinematics/JointAngles.proto
[ INFO (RSB.COMMON) ]  Emitting data holder and deserializer, extractor, offset for #<FILE-SET-DESC (1) {100AF6A553}>
  0: (RSBAG.TRANSFORM:MAKE-TRANSFORM :RSB-EVENT-0.7 :|.rst.kinematics.JointAngles| :CONVERTER
                                     (:FUNDAMENTAL-VOID :FUNDAMENTAL-UTF-8-STRING :FUNDAMENTAL-BYTES :FUNDAMENTAL-DOUBLE
:FUNDAMENTAL-FLOAT :FUNDAMENTAL-UINT64
                                      :FUNDAMENTAL-INT64 :FUNDAMENTAL-UINT32 :FUNDAMENTAL-INT32 :PROTOCOL-BUFFER))
  0: RSBAG.TRANSFORM:MAKE-TRANSFORM returned #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>
[ INFO (RSBAG.TOOLS.CAT) ]  Replaying using connection #<REPLAY-BAG-CONNECTION (1) {10092FC183}>
  0: (RSBAG.TRANSFORM:DECODE #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION .rst.kinematics.JointAngles
{100890E523}>
                             #(226 6 21 10 16 172 135 16 180 103 249 64 140 166 24 31 3 149 199 111 109 16 195 8 50 21 47 111 110 99 105 108 108
97 47 99 109 100 47 112 111
                               115 47 97 108 108 47 74 34 10 32 36 135 191 189 36 135 191 61 36 135 191 61 36 ...))
    1: (RSBAG.TRANSFORM::TRANSFORM-WIRE-SCHEMA #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>)
    1: RSBAG.TRANSFORM::TRANSFORM-WIRE-SCHEMA returned :|.rst.kinematics.JointAngles|
    1: (RSBAG.TRANSFORM::TRANSFORM-CONVERTER #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>)
    1: RSBAG.TRANSFORM::TRANSFORM-CONVERTER returned
         (:FUNDAMENTAL-VOID :FUNDAMENTAL-UTF-8-STRING :FUNDAMENTAL-BYTES :FUNDAMENTAL-DOUBLE
:FUNDAMENTAL-FLOAT :FUNDAMENTAL-UINT64 :FUNDAMENTAL-INT64 :FUNDAMENTAL-UINT32
          :FUNDAMENTAL-INT32 :PROTOCOL-BUFFER)
    1: (RSBAG.TRANSFORM::%TRANSFORM-HOLDER #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>)
    1: RSBAG.TRANSFORM::%TRANSFORM-HOLDER returned #<RSB.PROTOCOL:NOTIFICATION {1008A473A3}>
    1: (RSBAG.TRANSFORM::BYTES->STRING #(47 111 110 99 105 108 108 97 47 99 109 100 47 112 111 115 47 97 108 108 47))
    1: RSBAG.TRANSFORM::BYTES->STRING returned "/oncilla/cmd/pos/all/" 
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911668681185)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:28.681185+02:00
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911668681188)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:28.681188+02:00
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911668800470)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:28.800470+02:00
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911668807416)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:28.807416+02:00
    1: (RSBAG.TRANSFORM::BYTES->KEYWORD #(114 115 98 46 119 105 114 101 45 115 99 104 101 109 97))
    1: RSBAG.TRANSFORM::BYTES->KEYWORD returned :RSB.WIRE-SCHEMA 15
    1: (RSBAG.TRANSFORM::BYTES->STRING #(46 114 115 116 46 107 105 110 101 109 97 116 105 99 115 46 74 111 105 110 116 65 110
103 108 101 115))
    1: RSBAG.TRANSFORM::BYTES->STRING returned ".rst.kinematics.JointAngles" 
  0: RSBAG.TRANSFORM:DECODE returned #<RSB:EVENT /oncilla/cmd/pos/all/ #<RST.KINEMATICS:JOINT-ANGLES {1007FBAA03}>
0AF507E3>
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Event
  Scope          : /oncilla/cmd/pos/all/
  Id             : 0AF507E3-1852-5C36-8654-9EACF0C3FB12
  Sequence-Number: 1091
  Origin         : AC8710B4-67F9-408C-A618-1F0395C76F6D
  Method         : N/A
Timestamps
  Create : 2012-07-10T11:14:28.681185+02:00
  Send   : 2012-07-10T11:14:28.681188+02:00
  Receive: 2012-07-10T11:14:28.800470+02:00
  Deliver: 2012-07-10T11:14:28.807416+02:00
Meta-Data
  Rsb.Wire-Schema: .rst.kinematics.JointAngles
Payload (RST.KINEMATICS:JOINT-ANGLES)
  #<JOINT-ANGLES {1007FBAA03}>
    Angles: 
      -0.09351948f0
      0.09351948f0
      0.09351948f0
      -0.09351948f0
      0.0f0
      0.5f0
      0.0f0
      0.0f0
  0: (RSBAG.TRANSFORM:DECODE #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION .rst.kinematics.JointAngles
{100890E523}>
                             #(226 6 21 10 16 172 135 16 180 103 249 64 140 166 24 31 3 149 199 111 109 16 196 8 50 21 47 111 110 99 105 108 108
97 47 99 109 100 47 112 111
                               115 47 97 108 108 47 74 34 10 32 56 215 201 189 56 215 201 61 56 215 201 61 56 ...))
    1: (RSBAG.TRANSFORM::TRANSFORM-WIRE-SCHEMA #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>)
    1: RSBAG.TRANSFORM::TRANSFORM-WIRE-SCHEMA returned :|.rst.kinematics.JointAngles|
    1: (RSBAG.TRANSFORM::TRANSFORM-CONVERTER #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>)
    1: RSBAG.TRANSFORM::TRANSFORM-CONVERTER returned
         (:FUNDAMENTAL-VOID :FUNDAMENTAL-UTF-8-STRING :FUNDAMENTAL-BYTES :FUNDAMENTAL-DOUBLE
:FUNDAMENTAL-FLOAT :FUNDAMENTAL-UINT64 :FUNDAMENTAL-INT64 :FUNDAMENTAL-UINT32
          :FUNDAMENTAL-INT32 :PROTOCOL-BUFFER)
    1: (RSBAG.TRANSFORM::%TRANSFORM-HOLDER #<RSBAG.TRANSFORM::RSB-EVENT/PAYLOAD-CONVERSION
.rst.kinematics.JointAngles {100890E523}>)
    1: RSBAG.TRANSFORM::%TRANSFORM-HOLDER returned #<RSB.PROTOCOL:NOTIFICATION {100B794453}>
    1: (RSBAG.TRANSFORM::BYTES->STRING #(47 111 110 99 105 108 108 97 47 99 109 100 47 112 111 115 47 97 108 108 47))
    1: RSBAG.TRANSFORM::BYTES->STRING returned "/oncilla/cmd/pos/all/" 
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911668691411)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:28.691411+02:00
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911668691413)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:28.691413+02:00
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911669114100)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:29.114100+02:00
    1: (RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP 1341911669114147)
    1: RSBAG.TRANSFORM::UNIX-MICROSECONDS->TIMESTAMP returned @2012-07-10T11:14:29.114147+02:00
    1: (RSBAG.TRANSFORM::BYTES->KEYWORD #(114 115 98 46 119 105 114 101 45 115 99 104 101 109 97))
    1: RSBAG.TRANSFORM::BYTES->KEYWORD returned :RSB.WIRE-SCHEMA 15
    1: (RSBAG.TRANSFORM::BYTES->STRING #(46 114 115 116 46 107 105 110 101 109 97 116 105 99 115 46 74 111 105 110 116 65 110
103 108 101 115))
    1: RSBAG.TRANSFORM::BYTES->STRING returned ".rst.kinematics.JointAngles" 
  0: RSBAG.TRANSFORM:DECODE returned #<RSB:EVENT /oncilla/cmd/pos/all/ #<RST.KINEMATICS:JOINT-ANGLES {1008C60483}>
AB69EE80>
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Event
  Scope          : /oncilla/cmd/pos/all/
  Id             : AB69EE80-979D-531B-ABDE-6051A919B058
  Sequence-Number: 1092
  Origin         : AC8710B4-67F9-408C-A618-1F0395C76F6D
  Method         : N/A
Timestamps
  Create : 2012-07-10T11:14:28.691411+02:00
  Send   : 2012-07-10T11:14:28.691413+02:00
  Receive: 2012-07-10T11:14:29.114100+02:00
  Deliver: 2012-07-10T11:14:29.114147+02:00
Meta-Data
  Rsb.Wire-Schema: .rst.kinematics.JointAngles
Payload (RST.KINEMATICS:JOINT-ANGLES)
  #<JOINT-ANGLES {1008C60483}>
    Angles: 
      -0.09855503f0
      0.09855503f0
      0.09855503f0
      -0.09855503f0
      0.0f0
      0.5f0
      0.0f0
      0.0f0

bag-cat0.8 (not working)

bag-cat -E 1 -I /usr/share/rst/proto/stable/ -l /usr/share/rst/proto/stable/rst/kinematics/JointAngles.proto --log-level=trace --trace
'"RSBAG.TRANSFORM"' --style=detailed /usr/share/cca-oncilla/examples/oncilla.tide
WARNING:
   Failed to load Spread library: Unable to load any of the alternatives:
   ("libspread-without-signal-blocking.so" "libspread.so" "libspread.so.2" 
    "libspread.so.2.0" "libspread.so.1").
   Did you set LD_LIBRARY_PATH?
   Spread transport will now be disabled.
[ INFO (RSB.COMMON) ]  Processing IDL file #P"/usr/share/rst/proto/stable/rst/kinematics/JointAngles.proto" 
[ INFO (RSB.COMMON) ]  Parsing data definition from /usr/share/rst/proto/stable/rst/kinematics/JointAngles.proto
[ INFO (RSB.COMMON) ]  Emitting data holder and deserializer, extractor, offset for #<FILE-SET-DESC (1) {100AF7A753}>
  0: (RSBAG.TRANSFORM:MAKE-TRANSFORM :RSB-EVENT-0.7 :|.rst.kinematics.JointAngles| :CONVERTER
                                     (:FUNDAMENTAL-VOID :FUNDAMENTAL-UTF-8-STRING :FUNDAMENTAL-BYTES :FUNDAMENTAL-DOUBLE
:FUNDAMENTAL-FLOAT :FUNDAMENTAL-UINT64
                                      :FUNDAMENTAL-INT64 :FUNDAMENTAL-UINT32 :FUNDAMENTAL-INT32 :PROTOCOL-BUFFER))
    1: (RSBAG.TRANSFORM:FIND-TRANSFORM-CLASS :RSB-EVENT-0.7)
[ INFO (RSBAG.TOOLS.CAT) ]  Replaying using connection #<REPLAY-BAG-CONNECTION (1) {10092907B3}>
[ ERROR (RSBAG.RSB.REPLAY) ]  Failed to retrieve an event for replay: Failed to retrieve next event from #<REPLAY-BAG-CONNECTION
(1) {10092907B3}> for replay according to strategy #<AS-FAST-AS-POSSIBLE [0, 1[ {10091C8803}> Caused by:
> There is no primary method for the generic function #<STANDARD-GENERIC-FUNCTION RSB.FORMATTING:FORMAT-EVENT (50)>when
called with arguments (#(226 6 21 10 16 172 135 16 180 103 249 64 140 166 24 31 3 149 199 111 109 16 195 8 50 21 47 111 110 99 105 108
108 97 47 99 109 100 47 112 111 115 47 97 108 108 47 74 34 10 32 36 135 191 189 36 135 191 61 36 135 191 61 36 ...)
#<RSB.FORMATTING:STYLE-DETAILED {100A43DEA3}> #<SYNONYM-STREAM :SYMBOL SB-SYS:*STDOUT* {1000369C03}>).
> See also:
>   The ANSI Standard, Section 7.6.6.2
[ WARN (RSBAG.TOOLS.CAT) ]  Restart LOG not found; Doing nothing.
There is no primary method for the generic function
  #<STANDARD-GENERIC-FUNCTION RSB.FORMATTING:FORMAT-EVENT (50)>
when called with arguments
  (#(226 6 21 10 16 172 135 16 180 103 249 64 140 166 24 31 3 149 199 111 109 16 195 8 50 21 47 111 110 99 105 108 108 97 47 99 109
100 47 112 111 115 47 97 108 108 47 74
     34 10 32 36 135 191 189 36 135 191 61 36 135 191 61 36 ...)
   #<RSB.FORMATTING:STYLE-DETAILED {100A43DEA3}> #<SYNONYM-STREAM :SYMBOL SB-SYS:*STDOUT* {1000369C03}>).
See also:
  The ANSI Standard, Section 7.6.6.2

#2 - 07/25/2012 04:20 PM - J. Moringen
- Subject changed from Regression in bag-play 0.8 - rst type payload seems to be broken to bag-play 0.8 does not decode type RSB-EVENT-0.7
- Status changed from New to In Progress
- Target version set to rsb-0.9
- % Done changed from 0 to 30

#3 - 07/25/2012 09:50 PM - J. Moringen
- Status changed from In Progress to Resolved
- % Done changed from 30 to 100

Applied in changeset r502.

Files
oncilla.tide 564 KB 07/25/2012 Anonymous
